<?php

declare(strict_types=1);

namespace Mm\Masterfilter\Domain\Model;


/**
 * This file is part of the "masterfilter" Extension for TYPO3 CMS.
 *
 * For the full copyright and license information, please read the
 * LICENSE.txt file that was distributed with this source code.
 *
 * (c) 2022 Andreas Jud <ajud@millemedia.de>, Millemedia GmbH
 */

/**
 * Applications
 */
class Applications extends \TYPO3\CMS\Extbase\DomainObject\AbstractEntity
{

    /**
     * name
     *
     * @var string
     */
    protected $name = '';

    /**
     * market
     *
     * @var \Mm\Masterfilter\Domain\Model\Markets
     */
    protected $market = null;

    /**
     * Returns the name
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Sets the name
     *
     * @param string $name
     * @return void
     */
    public function setName(string $name)
    {
        $this->name = $name;
    }

    /**
     * Returns the market
     *
     * @return \Mm\Masterfilter\Domain\Model\Markets
     */
    public function getMarket()
    {
        return $this->market;
    }

    /**
     * Sets the market
     *
     * @param \Mm\Masterfilter\Domain\Model\Markets $market
     * @return void
     */
    public function setMarket(\Mm\Masterfilter\Domain\Model\Markets $market)
    {
        $this->market = $market;
    }
}
