<?php

declare(strict_types=1);

namespace Mm\Masterfilter\Domain\Model;


/**
 * This file is part of the "masterfilter" Extension for TYPO3 CMS.
 *
 * For the full copyright and license information, please read the
 * LICENSE.txt file that was distributed with this source code.
 *
 * (c) 2022 Andreas Jud <ajud@millemedia.de>, Millemedia GmbH
 */

/**
 * Mfproducts
 */
class Mfproducts extends \TYPO3\CMS\Extbase\DomainObject\AbstractEntity
{

    /**
     * productId
     *
     * @var string
     */
    protected $productId = '';

    /**
     * brandName
     *
     * @var string
     */
    protected $brandName = '';

    /**
     * productHeader
     *
     * @var string
     */
    protected $productHeader = '';

    /**
     * productDescription
     *
     * @var string
     */
    protected $productDescription = '';

    /**
     * featuresBenefits
     *
     * @var string
     */
    protected $featuresBenefits = '';

    /**
     * technicalSpecification
     *
     * @var string
     */
    protected $technicalSpecification = '';

    /**
     * micronRatings
     *
     * @var string
     */
    protected $micronRatings = '';

    /**
     * filterProperties
     *
     * @var string
     */
    protected $filterProperties = '';

    /**
     * productImage
     *
     * @var \TYPO3\CMS\Extbase\Domain\Model\FileReference
     * @TYPO3\CMS\Extbase\Annotation\ORM\Cascade("remove")
     */
    protected $productImage = null;

    /**
     * productDocument
     *
     * @var \TYPO3\CMS\Extbase\Domain\Model\FileReference
     * @TYPO3\CMS\Extbase\Annotation\ORM\Cascade("remove")
     */
    protected $productDocument = null;

    /**
     * filterType
     *
     * @var \Mm\Masterfilter\Domain\Model\FilterType
     */
    protected $filterType = null;

    /**
     * productType
     *
     * @var \Mm\Masterfilter\Domain\Model\ProductType
     */
    protected $productType = null;

    /**
     * media
     *
     * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Mm\Masterfilter\Domain\Model\Media>
     * @TYPO3\CMS\Extbase\Annotation\ORM\Cascade("remove")
     */
    protected $media = null;

    /**
     * filterMediaType
     *
     * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Mm\Masterfilter\Domain\Model\FilterMediaType>
     * @TYPO3\CMS\Extbase\Annotation\ORM\Cascade("remove")
     */
    protected $filterMediaType = null;

    /**
     * applications
     *
     * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Mm\Masterfilter\Domain\Model\Applications>
     * @TYPO3\CMS\Extbase\Annotation\ORM\Cascade("remove")
     */
    protected $applications = null;

    /**
     * markets
     *
     * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Mm\Masterfilter\Domain\Model\Markets>
     * @TYPO3\CMS\Extbase\Annotation\ORM\Cascade("remove")
     */
    protected $markets = null;

    /**
     * slug
     *
     * @var string
     */
    protected $slug = '';

    /**
     * Returns the productId
     *
     * @return string
     */
    public function getProductId()
    {
        return $this->productId;
    }

    /**
     * Sets the productId
     *
     * @param string $productId
     * @return void
     */
    public function setProductId(string $productId)
    {
        $this->productId = $productId;
    }

    /**
     * Returns the brandName
     *
     * @return string
     */
    public function getBrandName()
    {
        return $this->brandName;
    }

    /**
     * Sets the brandName
     *
     * @param string $brandName
     * @return void
     */
    public function setBrandName(string $brandName)
    {
        $this->brandName = $brandName;
    }

    /**
     * Returns the productHeader
     *
     * @return string
     */
    public function getProductHeader()
    {
        return $this->productHeader;
    }

    /**
     * Sets the productHeader
     *
     * @param string $productHeader
     * @return void
     */
    public function setProductHeader(string $productHeader)
    {
        $this->productHeader = $productHeader;
    }

    /**
     * Returns the productDescription
     *
     * @return string
     */
    public function getProductDescription()
    {
        return $this->productDescription;
    }

    /**
     * Sets the productDescription
     *
     * @param string $productDescription
     * @return void
     */
    public function setProductDescription(string $productDescription)
    {
        $this->productDescription = $productDescription;
    }

    /**
     * Returns the featuresBenefits
     *
     * @return string
     */
    public function getFeaturesBenefits()
    {
        return $this->featuresBenefits;
    }

    /**
     * Sets the featuresBenefits
     *
     * @param string $featuresBenefits
     * @return void
     */
    public function setFeaturesBenefits(string $featuresBenefits)
    {
        $this->featuresBenefits = $featuresBenefits;
    }

    /**
     * Returns the technicalSpecification
     *
     * @return string
     */
    public function getTechnicalSpecification()
    {
        return $this->technicalSpecification;
    }

    /**
     * Sets the technicalSpecification
     *
     * @param string $technicalSpecification
     * @return void
     */
    public function setTechnicalSpecification(string $technicalSpecification)
    {
        $this->technicalSpecification = $technicalSpecification;
    }

    /**
     * Returns the micronRatings
     *
     * @return string
     */
    public function getMicronRatings()
    {
        return $this->micronRatings;
    }

    /**
     * Sets the micronRatings
     *
     * @param string $micronRatings
     * @return void
     */
    public function setMicronRatings(string $micronRatings)
    {
        $this->micronRatings = $micronRatings;
    }

    /**
     * Returns the productImage
     *
     * @return \TYPO3\CMS\Extbase\Domain\Model\FileReference
     */
    public function getProductImage()
    {
        return $this->productImage;
    }

    /**
     * Sets the productImage
     *
     * @param \TYPO3\CMS\Extbase\Domain\Model\FileReference $productImage
     * @return void
     */
    public function setProductImage(\TYPO3\CMS\Extbase\Domain\Model\FileReference $productImage)
    {
        $this->productImage = $productImage;
    }

    /**
     * Returns the productDocument
     *
     * @return \TYPO3\CMS\Extbase\Domain\Model\FileReference
     */
    public function getProductDocument()
    {
        return $this->productDocument;
    }

    /**
     * Sets the productDocument
     *
     * @param \TYPO3\CMS\Extbase\Domain\Model\FileReference $productDocument
     * @return void
     */
    public function setProductDocument(\TYPO3\CMS\Extbase\Domain\Model\FileReference $productDocument)
    {
        $this->productDocument = $productDocument;
    }

    /**
     * __construct
     */
    public function __construct()
    {

        // Do not remove the next line: It would break the functionality
        $this->initializeObject();
    }

    /**
     * Initializes all ObjectStorage properties when model is reconstructed from DB (where __construct is not called)
     * Do not modify this method!
     * It will be rewritten on each save in the extension builder
     * You may modify the constructor of this class instead
     *
     * @return void
     */
    public function initializeObject()
    {
        $this->media = $this->media ?: new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
        $this->filterMediaType = $this->filterMediaType ?: new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
        $this->applications = $this->applications ?: new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
        $this->markets = $this->markets ?: new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
    }

    /**
     * Adds a Applications
     *
     * @param \Mm\Masterfilter\Domain\Model\Applications $application
     * @return void
     */
    public function addApplication(\Mm\Masterfilter\Domain\Model\Applications $application)
    {
        $this->applications->attach($application);
    }

    /**
     * Removes a Applications
     *
     * @param \Mm\Masterfilter\Domain\Model\Applications $applicationToRemove The Applications to be removed
     * @return void
     */
    public function removeApplication(\Mm\Masterfilter\Domain\Model\Applications $applicationToRemove)
    {
        $this->applications->detach($applicationToRemove);
    }

    /**
     * Returns the applications
     *
     * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Mm\Masterfilter\Domain\Model\Applications>
     */
    public function getApplications()
    {
        return $this->applications;
    }

    /**
     * Sets the applications
     *
     * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Mm\Masterfilter\Domain\Model\Applications> $applications
     * @return void
     */
    public function setApplications(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $applications)
    {
        $this->applications = $applications;
    }

    /**
     * Returns the filterType
     *
     * @return \Mm\Masterfilter\Domain\Model\FilterType
     */
    public function getFilterType()
    {
        return $this->filterType;
    }

    /**
     * Sets the filterType
     *
     * @param \Mm\Masterfilter\Domain\Model\FilterType $filterType
     * @return void
     */
    public function setFilterType(\Mm\Masterfilter\Domain\Model\FilterType $filterType)
    {
        $this->filterType = $filterType;
    }

    /**
     * Returns the productType
     *
     * @return \Mm\Masterfilter\Domain\Model\ProductType
     */
    public function getProductType()
    {
        return $this->productType;
    }

    /**
     * Sets the productType
     *
     * @param \Mm\Masterfilter\Domain\Model\ProductType $productType
     * @return void
     */
    public function setProductType(\Mm\Masterfilter\Domain\Model\ProductType $productType)
    {
        $this->productType = $productType;
    }

    /**
     * Returns the filterProperties
     *
     * @return string filterProperties
     */
    public function getFilterProperties()
    {
        return $this->filterProperties;
    }

    /**
     * Sets the filterProperties
     *
     * @param string $filterProperties
     * @return void
     */
    public function setFilterProperties(string $filterProperties)
    {
        $this->filterProperties = $filterProperties;
    }

    /**
     * Adds a Markets
     *
     * @param \Mm\Masterfilter\Domain\Model\Markets $market
     * @return void
     */
    public function addMarket(\Mm\Masterfilter\Domain\Model\Markets $market)
    {
        $this->markets->attach($market);
    }

    /**
     * Removes a Markets
     *
     * @param \Mm\Masterfilter\Domain\Model\Markets $marketToRemove The Markets to be removed
     * @return void
     */
    public function removeMarket(\Mm\Masterfilter\Domain\Model\Markets $marketToRemove)
    {
        $this->markets->detach($marketToRemove);
    }

    /**
     * Returns the markets
     *
     * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Mm\Masterfilter\Domain\Model\Markets>
     */
    public function getMarkets()
    {
        return $this->markets;
    }

    /**
     * Sets the markets
     *
     * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Mm\Masterfilter\Domain\Model\Markets> $markets
     * @return void
     */
    public function setMarkets(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $markets)
    {
        $this->markets = $markets;
    }

    /**
     * Adds a FilterMediaType
     *
     * @param \Mm\Masterfilter\Domain\Model\FilterMediaType $filterMediaType
     * @return void
     */
    public function addFilterMediaType(\Mm\Masterfilter\Domain\Model\FilterMediaType $filterMediaType)
    {
        $this->filterMediaType->attach($filterMediaType);
    }

    /**
     * Removes a FilterMediaType
     *
     * @param \Mm\Masterfilter\Domain\Model\FilterMediaType $filterMediaTypeToRemove The FilterMediaType to be removed
     * @return void
     */
    public function removeFilterMediaType(\Mm\Masterfilter\Domain\Model\FilterMediaType $filterMediaTypeToRemove)
    {
        $this->filterMediaType->detach($filterMediaTypeToRemove);
    }

    /**
     * Returns the filterMediaType
     *
     * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Mm\Masterfilter\Domain\Model\FilterMediaType>
     */
    public function getFilterMediaType()
    {
        return $this->filterMediaType;
    }

    /**
     * Sets the filterMediaType
     *
     * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Mm\Masterfilter\Domain\Model\FilterMediaType> $filterMediaType
     * @return void
     */
    public function setFilterMediaType(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $filterMediaType)
    {
        $this->filterMediaType = $filterMediaType;
    }

    /**
     * Adds a Media
     *
     * @param \Mm\Masterfilter\Domain\Model\Media $medium
     * @return void
     */
    public function addMedium(\Mm\Masterfilter\Domain\Model\Media $medium)
    {
        $this->media->attach($medium);
    }

    /**
     * Removes a Media
     *
     * @param \Mm\Masterfilter\Domain\Model\Media $mediumToRemove The Media to be removed
     * @return void
     */
    public function removeMedium(\Mm\Masterfilter\Domain\Model\Media $mediumToRemove)
    {
        $this->media->detach($mediumToRemove);
    }

    /**
     * Returns the media
     *
     * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Mm\Masterfilter\Domain\Model\Media>
     */
    public function getMedia()
    {
        return $this->media;
    }

    /**
     * Sets the media
     *
     * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Mm\Masterfilter\Domain\Model\Media> $media
     * @return void
     */
    public function setMedia(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $media)
    {
        $this->media = $media;
    }

    /**
     * Returns the slug
     *
     * @return string
     */
    public function getSlug()
    {
        return $this->slug;
    }

    /**
     * Sets the slug
     *
     * @param string $slug
     * @return void
     */
    public function setSlug(string $slug)
    {
        $this->slug = $slug;
    }
}
