<?php

declare(strict_types=1);

namespace Mm\Masterfilter\Tests\Unit\Domain\Model;

use PHPUnit\Framework\MockObject\MockObject;
use TYPO3\TestingFramework\Core\AccessibleObjectInterface;
use TYPO3\TestingFramework\Core\Unit\UnitTestCase;

/**
 * Test case
 *
 * @author Andreas Jud <ajud@millemedia.de>
 */
class MfProductsTest extends UnitTestCase
{
    /**
     * @var \Mm\Masterfilter\Domain\Model\MfProducts|MockObject|AccessibleObjectInterface
     */
    protected $subject;

    protected function setUp(): void
    {
        parent::setUp();

        $this->subject = $this->getAccessibleMock(
            \Mm\Masterfilter\Domain\Model\MfProducts::class,
            ['dummy']
        );
    }

    protected function tearDown(): void
    {
        parent::tearDown();
    }

    /**
     * @test
     */
    public function getProductIdReturnsInitialValueForString(): void
    {
        self::assertSame(
            '',
            $this->subject->getProductId()
        );
    }

    /**
     * @test
     */
    public function setProductIdForStringSetsProductId(): void
    {
        $this->subject->setProductId('Conceived at T3CON10');

        self::assertEquals('Conceived at T3CON10', $this->subject->_get('productId'));
    }

    /**
     * @test
     */
    public function getBrandNameReturnsInitialValueForString(): void
    {
        self::assertSame(
            '',
            $this->subject->getBrandName()
        );
    }

    /**
     * @test
     */
    public function setBrandNameForStringSetsBrandName(): void
    {
        $this->subject->setBrandName('Conceived at T3CON10');

        self::assertEquals('Conceived at T3CON10', $this->subject->_get('brandName'));
    }

    /**
     * @test
     */
    public function getProductHeaderReturnsInitialValueForString(): void
    {
        self::assertSame(
            '',
            $this->subject->getProductHeader()
        );
    }

    /**
     * @test
     */
    public function setProductHeaderForStringSetsProductHeader(): void
    {
        $this->subject->setProductHeader('Conceived at T3CON10');

        self::assertEquals('Conceived at T3CON10', $this->subject->_get('productHeader'));
    }

    /**
     * @test
     */
    public function getProductDescriptionReturnsInitialValueForString(): void
    {
        self::assertSame(
            '',
            $this->subject->getProductDescription()
        );
    }

    /**
     * @test
     */
    public function setProductDescriptionForStringSetsProductDescription(): void
    {
        $this->subject->setProductDescription('Conceived at T3CON10');

        self::assertEquals('Conceived at T3CON10', $this->subject->_get('productDescription'));
    }

    /**
     * @test
     */
    public function getFeaturesBenefitsReturnsInitialValueForString(): void
    {
        self::assertSame(
            '',
            $this->subject->getFeaturesBenefits()
        );
    }

    /**
     * @test
     */
    public function setFeaturesBenefitsForStringSetsFeaturesBenefits(): void
    {
        $this->subject->setFeaturesBenefits('Conceived at T3CON10');

        self::assertEquals('Conceived at T3CON10', $this->subject->_get('featuresBenefits'));
    }

    /**
     * @test
     */
    public function getTechnicalSpecificationReturnsInitialValueForString(): void
    {
        self::assertSame(
            '',
            $this->subject->getTechnicalSpecification()
        );
    }

    /**
     * @test
     */
    public function setTechnicalSpecificationForStringSetsTechnicalSpecification(): void
    {
        $this->subject->setTechnicalSpecification('Conceived at T3CON10');

        self::assertEquals('Conceived at T3CON10', $this->subject->_get('technicalSpecification'));
    }

    /**
     * @test
     */
    public function getMicronRatingsReturnsInitialValueForString(): void
    {
        self::assertSame(
            '',
            $this->subject->getMicronRatings()
        );
    }

    /**
     * @test
     */
    public function setMicronRatingsForStringSetsMicronRatings(): void
    {
        $this->subject->setMicronRatings('Conceived at T3CON10');

        self::assertEquals('Conceived at T3CON10', $this->subject->_get('micronRatings'));
    }

    /**
     * @test
     */
    public function getStandardsReturnsInitialValueForString(): void
    {
        self::assertSame(
            '',
            $this->subject->getStandards()
        );
    }

    /**
     * @test
     */
    public function setStandardsForStringSetsStandards(): void
    {
        $this->subject->setStandards('Conceived at T3CON10');

        self::assertEquals('Conceived at T3CON10', $this->subject->_get('standards'));
    }

    /**
     * @test
     */
    public function getProductImageReturnsInitialValueForFileReference(): void
    {
        self::assertEquals(
            null,
            $this->subject->getProductImage()
        );
    }

    /**
     * @test
     */
    public function setProductImageForFileReferenceSetsProductImage(): void
    {
        $fileReferenceFixture = new \TYPO3\CMS\Extbase\Domain\Model\FileReference();
        $this->subject->setProductImage($fileReferenceFixture);

        self::assertEquals($fileReferenceFixture, $this->subject->_get('productImage'));
    }

    /**
     * @test
     */
    public function getProductDocumentReturnsInitialValueForFileReference(): void
    {
        self::assertEquals(
            null,
            $this->subject->getProductDocument()
        );
    }

    /**
     * @test
     */
    public function setProductDocumentForFileReferenceSetsProductDocument(): void
    {
        $fileReferenceFixture = new \TYPO3\CMS\Extbase\Domain\Model\FileReference();
        $this->subject->setProductDocument($fileReferenceFixture);

        self::assertEquals($fileReferenceFixture, $this->subject->_get('productDocument'));
    }
}
