<?php

declare(strict_types=1);

namespace Mm\Masterfilter\Tests\Unit\Domain\Model;

use PHPUnit\Framework\MockObject\MockObject;
use TYPO3\TestingFramework\Core\AccessibleObjectInterface;
use TYPO3\TestingFramework\Core\Unit\UnitTestCase;

/**
 * Test case
 *
 * @author Andreas Jud <ajud@millemedia.de>
 */
class MfproductsTest extends UnitTestCase
{
    /**
     * @var \Mm\Masterfilter\Domain\Model\Mfproducts|MockObject|AccessibleObjectInterface
     */
    protected $subject;

    protected function setUp(): void
    {
        parent::setUp();

        $this->subject = $this->getAccessibleMock(
            \Mm\Masterfilter\Domain\Model\Mfproducts::class,
            ['dummy']
        );
    }

    protected function tearDown(): void
    {
        parent::tearDown();
    }

    /**
     * @test
     */
    public function getProductIdReturnsInitialValueForString(): void
    {
        self::assertSame(
            '',
            $this->subject->getProductId()
        );
    }

    /**
     * @test
     */
    public function setProductIdForStringSetsProductId(): void
    {
        $this->subject->setProductId('Conceived at T3CON10');

        self::assertEquals('Conceived at T3CON10', $this->subject->_get('productId'));
    }

    /**
     * @test
     */
    public function getBrandNameReturnsInitialValueForString(): void
    {
        self::assertSame(
            '',
            $this->subject->getBrandName()
        );
    }

    /**
     * @test
     */
    public function setBrandNameForStringSetsBrandName(): void
    {
        $this->subject->setBrandName('Conceived at T3CON10');

        self::assertEquals('Conceived at T3CON10', $this->subject->_get('brandName'));
    }

    /**
     * @test
     */
    public function getProductHeaderReturnsInitialValueForString(): void
    {
        self::assertSame(
            '',
            $this->subject->getProductHeader()
        );
    }

    /**
     * @test
     */
    public function setProductHeaderForStringSetsProductHeader(): void
    {
        $this->subject->setProductHeader('Conceived at T3CON10');

        self::assertEquals('Conceived at T3CON10', $this->subject->_get('productHeader'));
    }

    /**
     * @test
     */
    public function getProductDescriptionReturnsInitialValueForString(): void
    {
        self::assertSame(
            '',
            $this->subject->getProductDescription()
        );
    }

    /**
     * @test
     */
    public function setProductDescriptionForStringSetsProductDescription(): void
    {
        $this->subject->setProductDescription('Conceived at T3CON10');

        self::assertEquals('Conceived at T3CON10', $this->subject->_get('productDescription'));
    }

    /**
     * @test
     */
    public function getFeaturesBenefitsReturnsInitialValueForString(): void
    {
        self::assertSame(
            '',
            $this->subject->getFeaturesBenefits()
        );
    }

    /**
     * @test
     */
    public function setFeaturesBenefitsForStringSetsFeaturesBenefits(): void
    {
        $this->subject->setFeaturesBenefits('Conceived at T3CON10');

        self::assertEquals('Conceived at T3CON10', $this->subject->_get('featuresBenefits'));
    }

    /**
     * @test
     */
    public function getTechnicalSpecificationReturnsInitialValueForString(): void
    {
        self::assertSame(
            '',
            $this->subject->getTechnicalSpecification()
        );
    }

    /**
     * @test
     */
    public function setTechnicalSpecificationForStringSetsTechnicalSpecification(): void
    {
        $this->subject->setTechnicalSpecification('Conceived at T3CON10');

        self::assertEquals('Conceived at T3CON10', $this->subject->_get('technicalSpecification'));
    }

    /**
     * @test
     */
    public function getMicronRatingsReturnsInitialValueForString(): void
    {
        self::assertSame(
            '',
            $this->subject->getMicronRatings()
        );
    }

    /**
     * @test
     */
    public function setMicronRatingsForStringSetsMicronRatings(): void
    {
        $this->subject->setMicronRatings('Conceived at T3CON10');

        self::assertEquals('Conceived at T3CON10', $this->subject->_get('micronRatings'));
    }

    /**
     * @test
     */
    public function getFilterPropertiesReturnsInitialValueForString(): void
    {
        self::assertSame(
            '',
            $this->subject->getFilterProperties()
        );
    }

    /**
     * @test
     */
    public function setFilterPropertiesForStringSetsFilterProperties(): void
    {
        $this->subject->setFilterProperties('Conceived at T3CON10');

        self::assertEquals('Conceived at T3CON10', $this->subject->_get('filterProperties'));
    }

    /**
     * @test
     */
    public function getProductImageReturnsInitialValueForFileReference(): void
    {
        self::assertEquals(
            null,
            $this->subject->getProductImage()
        );
    }

    /**
     * @test
     */
    public function setProductImageForFileReferenceSetsProductImage(): void
    {
        $fileReferenceFixture = new \TYPO3\CMS\Extbase\Domain\Model\FileReference();
        $this->subject->setProductImage($fileReferenceFixture);

        self::assertEquals($fileReferenceFixture, $this->subject->_get('productImage'));
    }

    /**
     * @test
     */
    public function getProductDocumentReturnsInitialValueForFileReference(): void
    {
        self::assertEquals(
            null,
            $this->subject->getProductDocument()
        );
    }

    /**
     * @test
     */
    public function setProductDocumentForFileReferenceSetsProductDocument(): void
    {
        $fileReferenceFixture = new \TYPO3\CMS\Extbase\Domain\Model\FileReference();
        $this->subject->setProductDocument($fileReferenceFixture);

        self::assertEquals($fileReferenceFixture, $this->subject->_get('productDocument'));
    }

    /**
     * @test
     */
    public function getFilterTypeReturnsInitialValueForFilterType(): void
    {
        self::assertEquals(
            null,
            $this->subject->getFilterType()
        );
    }

    /**
     * @test
     */
    public function setFilterTypeForFilterTypeSetsFilterType(): void
    {
        $filterTypeFixture = new \Mm\Masterfilter\Domain\Model\FilterType();
        $this->subject->setFilterType($filterTypeFixture);

        self::assertEquals($filterTypeFixture, $this->subject->_get('filterType'));
    }

    /**
     * @test
     */
    public function getProductTypeReturnsInitialValueForProductType(): void
    {
        self::assertEquals(
            null,
            $this->subject->getProductType()
        );
    }

    /**
     * @test
     */
    public function setProductTypeForProductTypeSetsProductType(): void
    {
        $productTypeFixture = new \Mm\Masterfilter\Domain\Model\ProductType();
        $this->subject->setProductType($productTypeFixture);

        self::assertEquals($productTypeFixture, $this->subject->_get('productType'));
    }

    /**
     * @test
     */
    public function getMediaReturnsInitialValueForMedia(): void
    {
        $newObjectStorage = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
        self::assertEquals(
            $newObjectStorage,
            $this->subject->getMedia()
        );
    }

    /**
     * @test
     */
    public function setMediaForObjectStorageContainingMediaSetsMedia(): void
    {
        $medium = new \Mm\Masterfilter\Domain\Model\Media();
        $objectStorageHoldingExactlyOneMedia = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
        $objectStorageHoldingExactlyOneMedia->attach($medium);
        $this->subject->setMedia($objectStorageHoldingExactlyOneMedia);

        self::assertEquals($objectStorageHoldingExactlyOneMedia, $this->subject->_get('media'));
    }

    /**
     * @test
     */
    public function addMediumToObjectStorageHoldingMedia(): void
    {
        $medium = new \Mm\Masterfilter\Domain\Model\Media();
        $mediaObjectStorageMock = $this->getMockBuilder(\TYPO3\CMS\Extbase\Persistence\ObjectStorage::class)
            ->onlyMethods(['attach'])
            ->disableOriginalConstructor()
            ->getMock();

        $mediaObjectStorageMock->expects(self::once())->method('attach')->with(self::equalTo($medium));
        $this->subject->_set('media', $mediaObjectStorageMock);

        $this->subject->addMedium($medium);
    }

    /**
     * @test
     */
    public function removeMediumFromObjectStorageHoldingMedia(): void
    {
        $medium = new \Mm\Masterfilter\Domain\Model\Media();
        $mediaObjectStorageMock = $this->getMockBuilder(\TYPO3\CMS\Extbase\Persistence\ObjectStorage::class)
            ->onlyMethods(['detach'])
            ->disableOriginalConstructor()
            ->getMock();

        $mediaObjectStorageMock->expects(self::once())->method('detach')->with(self::equalTo($medium));
        $this->subject->_set('media', $mediaObjectStorageMock);

        $this->subject->removeMedium($medium);
    }

    /**
     * @test
     */
    public function getFilterMediaTypeReturnsInitialValueForFilterMediaType(): void
    {
        $newObjectStorage = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
        self::assertEquals(
            $newObjectStorage,
            $this->subject->getFilterMediaType()
        );
    }

    /**
     * @test
     */
    public function setFilterMediaTypeForObjectStorageContainingFilterMediaTypeSetsFilterMediaType(): void
    {
        $filterMediaType = new \Mm\Masterfilter\Domain\Model\FilterMediaType();
        $objectStorageHoldingExactlyOneFilterMediaType = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
        $objectStorageHoldingExactlyOneFilterMediaType->attach($filterMediaType);
        $this->subject->setFilterMediaType($objectStorageHoldingExactlyOneFilterMediaType);

        self::assertEquals($objectStorageHoldingExactlyOneFilterMediaType, $this->subject->_get('filterMediaType'));
    }

    /**
     * @test
     */
    public function addFilterMediaTypeToObjectStorageHoldingFilterMediaType(): void
    {
        $filterMediaType = new \Mm\Masterfilter\Domain\Model\FilterMediaType();
        $filterMediaTypeObjectStorageMock = $this->getMockBuilder(\TYPO3\CMS\Extbase\Persistence\ObjectStorage::class)
            ->onlyMethods(['attach'])
            ->disableOriginalConstructor()
            ->getMock();

        $filterMediaTypeObjectStorageMock->expects(self::once())->method('attach')->with(self::equalTo($filterMediaType));
        $this->subject->_set('filterMediaType', $filterMediaTypeObjectStorageMock);

        $this->subject->addFilterMediaType($filterMediaType);
    }

    /**
     * @test
     */
    public function removeFilterMediaTypeFromObjectStorageHoldingFilterMediaType(): void
    {
        $filterMediaType = new \Mm\Masterfilter\Domain\Model\FilterMediaType();
        $filterMediaTypeObjectStorageMock = $this->getMockBuilder(\TYPO3\CMS\Extbase\Persistence\ObjectStorage::class)
            ->onlyMethods(['detach'])
            ->disableOriginalConstructor()
            ->getMock();

        $filterMediaTypeObjectStorageMock->expects(self::once())->method('detach')->with(self::equalTo($filterMediaType));
        $this->subject->_set('filterMediaType', $filterMediaTypeObjectStorageMock);

        $this->subject->removeFilterMediaType($filterMediaType);
    }

    /**
     * @test
     */
    public function getApplicationsReturnsInitialValueForApplications(): void
    {
        $newObjectStorage = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
        self::assertEquals(
            $newObjectStorage,
            $this->subject->getApplications()
        );
    }

    /**
     * @test
     */
    public function setApplicationsForObjectStorageContainingApplicationsSetsApplications(): void
    {
        $application = new \Mm\Masterfilter\Domain\Model\Applications();
        $objectStorageHoldingExactlyOneApplications = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
        $objectStorageHoldingExactlyOneApplications->attach($application);
        $this->subject->setApplications($objectStorageHoldingExactlyOneApplications);

        self::assertEquals($objectStorageHoldingExactlyOneApplications, $this->subject->_get('applications'));
    }

    /**
     * @test
     */
    public function addApplicationToObjectStorageHoldingApplications(): void
    {
        $application = new \Mm\Masterfilter\Domain\Model\Applications();
        $applicationsObjectStorageMock = $this->getMockBuilder(\TYPO3\CMS\Extbase\Persistence\ObjectStorage::class)
            ->onlyMethods(['attach'])
            ->disableOriginalConstructor()
            ->getMock();

        $applicationsObjectStorageMock->expects(self::once())->method('attach')->with(self::equalTo($application));
        $this->subject->_set('applications', $applicationsObjectStorageMock);

        $this->subject->addApplication($application);
    }

    /**
     * @test
     */
    public function removeApplicationFromObjectStorageHoldingApplications(): void
    {
        $application = new \Mm\Masterfilter\Domain\Model\Applications();
        $applicationsObjectStorageMock = $this->getMockBuilder(\TYPO3\CMS\Extbase\Persistence\ObjectStorage::class)
            ->onlyMethods(['detach'])
            ->disableOriginalConstructor()
            ->getMock();

        $applicationsObjectStorageMock->expects(self::once())->method('detach')->with(self::equalTo($application));
        $this->subject->_set('applications', $applicationsObjectStorageMock);

        $this->subject->removeApplication($application);
    }

    /**
     * @test
     */
    public function getMarketsReturnsInitialValueForMarkets(): void
    {
        $newObjectStorage = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
        self::assertEquals(
            $newObjectStorage,
            $this->subject->getMarkets()
        );
    }

    /**
     * @test
     */
    public function setMarketsForObjectStorageContainingMarketsSetsMarkets(): void
    {
        $market = new \Mm\Masterfilter\Domain\Model\Markets();
        $objectStorageHoldingExactlyOneMarkets = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
        $objectStorageHoldingExactlyOneMarkets->attach($market);
        $this->subject->setMarkets($objectStorageHoldingExactlyOneMarkets);

        self::assertEquals($objectStorageHoldingExactlyOneMarkets, $this->subject->_get('markets'));
    }

    /**
     * @test
     */
    public function addMarketToObjectStorageHoldingMarkets(): void
    {
        $market = new \Mm\Masterfilter\Domain\Model\Markets();
        $marketsObjectStorageMock = $this->getMockBuilder(\TYPO3\CMS\Extbase\Persistence\ObjectStorage::class)
            ->onlyMethods(['attach'])
            ->disableOriginalConstructor()
            ->getMock();

        $marketsObjectStorageMock->expects(self::once())->method('attach')->with(self::equalTo($market));
        $this->subject->_set('markets', $marketsObjectStorageMock);

        $this->subject->addMarket($market);
    }

    /**
     * @test
     */
    public function removeMarketFromObjectStorageHoldingMarkets(): void
    {
        $market = new \Mm\Masterfilter\Domain\Model\Markets();
        $marketsObjectStorageMock = $this->getMockBuilder(\TYPO3\CMS\Extbase\Persistence\ObjectStorage::class)
            ->onlyMethods(['detach'])
            ->disableOriginalConstructor()
            ->getMock();

        $marketsObjectStorageMock->expects(self::once())->method('detach')->with(self::equalTo($market));
        $this->subject->_set('markets', $marketsObjectStorageMock);

        $this->subject->removeMarket($market);
    }
}
