<?php
defined('TYPO3') || die();

(static function() {
    \TYPO3\CMS\Extbase\Utility\ExtensionUtility::configurePlugin(
        'Masterfilter',
        'Mfproducts',
        [
            \Mm\Masterfilter\Controller\MfproductsController::class => 'list, show, listProd, listMed, listFilType, listMar, listApp'
        ],
        // non-cacheable actions
        [
            \Mm\Masterfilter\Controller\MfproductsController::class => ''
        ]
    );

    \TYPO3\CMS\Extbase\Utility\ExtensionUtility::configurePlugin(
        'Masterfilter',
        'Mfrelated',
        [
            \Mm\Masterfilter\Controller\MfproductsController::class => 'listApp, show'
        ],
        // non-cacheable actions
        [
            \Mm\Masterfilter\Controller\MfproductsController::class => ''
        ]
    );

    // wizards
    \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addPageTSConfig(
        'mod {
            wizards.newContentElement.wizardItems.plugins {
                elements {
                    mfproducts {
                        iconIdentifier = masterfilter-plugin-mfproducts
                        title = LLL:EXT:masterfilter/Resources/Private/Language/locallang_db.xlf:tx_masterfilter_mfproducts.name
                        description = LLL:EXT:masterfilter/Resources/Private/Language/locallang_db.xlf:tx_masterfilter_mfproducts.description
                        tt_content_defValues {
                            CType = list
                            list_type = masterfilter_mfproducts
                        }
                    }
                    mfrelated {
                        iconIdentifier = masterfilter-plugin-mfrelated
                        title = LLL:EXT:masterfilter/Resources/Private/Language/locallang_db.xlf:tx_masterfilter_mfrelated.name
                        description = LLL:EXT:masterfilter/Resources/Private/Language/locallang_db.xlf:tx_masterfilter_mfrelated.description
                        tt_content_defValues {
                            CType = list
                            list_type = masterfilter_mfrelated
                        }
                    }
                }
                show = *
            }
       }'
    );
})();
