# Changelog

**Note:** Breaking changes are marked with !!!

See [Upgrade instructions and breaking changes](/Documentation/Changelog/UpgradeInstructions.md) for some details on
breaking changes and how to handle them

| Version      | Release Date | Description                                                                                                                                                                                                           |
|--------------|--------------|-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| 10.3.1       | 2022-06-07   | Small bugfix update: Prevent exception on form submit, repair CSV/XLS/RSS in Pi2                                                                                                                                      |
| 10.3.0       | 2022-06-06   | JS validation opens tab with first error field on morestep forms, Fix overrule TS settings, Fix pagebrowser in backend module, Fix finisher runner, Some more smaller fixes and code cleanups                         |
| 10.2.0       | 2022-05-25   | Fix some tests, XLS export should be opened in a new window, fix some undefined array keys                                                                                                                            |
| 10.1.0       | 2022-04-13   | Feature: New form validation: Add callbacks on form submits with errors, scroll to error field on submit                                                                                                              |
| 10.0.0 (!!!) | 2022-04-10   | Feature: Remove jQuery, parsley.js and other old JS frameworks and replace it                                                                                                                                         |
| 9.0.0 (!!!)  | 2022-11-11   | Feature: Add Support TYPO3 11, drop support for TYPO3 10                                                                                                                                                              |
|              |              | Feature: Allow to disable ip-api.com (Stefan Busemann)                                                                                                                                                                |
|              |              | Feature: Provide local dev environment (Marcus Schwemer)                                                                                                                                                              |
|              |              | Feature: Make screenshots on acceptance test failure (Marcus Schwemer)                                                                                                                                                |
|              |              | Task: PHP8 compatibility (Marcus Schwemer / Georg Ringer)                                                                                                                                                             |
|              |              | Task: Anonymize tests (Marcus Schwemer)                                                                                                                                                                               |
|              |              | Docs: Merge pull request #730 from DavidBruchmann/develop (David Bruchmann)                                                                                                                                           |
|              |              | Docs: add changes for TYPO3 11 (Stefan Busemann)                                                                                                                                                                      |
|              |              | Docs: Add general upgrade instructions (Stefan Busemann)                                                                                                                                                              |
| 8.4.1        | 2021-08-11   | Task: Also Sanitize CSV and XLS export in Pi2 (not only the export in the backend module)                                                                                                                             |
| 8.4.0        | 2021-08-11   | Task: Sanitize CSV and XLS export against excel hacks (see https://typo3.org/security/advisory/typo3-psa-2021-002)                                                                                                    |
|              |              | Task: Add automatic test via github actions                                                                                                                                                                           |
| 8.3.3        | 2021-07-27   | Bugfix: Fix some more typehint problems                                                                                                                                                                               |
|              |              | Bugfix: Fix a problem with start- and endtime in backend records                                                                                                                                                      |
| 8.3.2        | 2021-04-30   | Bugfix: Fix typehint error with overwriteValueFromTypoScript()                                                                                                                                                        |
| 8.3.1        | 2021-03-08   | Bugfix: Don't validate captcha fields of already persisted mails (in double optin)                                                                                                                                    |
| 8.3.0        | 2021-02-16   | Feature: Add autodeployment functionality to TER                                                                                                                                                                      |
|              |              | Bugfix: Foreign-Validator compatibility to core methods                                                                                                                                                               |
|              |              | Bugfix: Reanimate sending emails to backend users                                                                                                                                                                     |
|              |              | Bugfix: Harden template utility functions against type errors                                                                                                                                                         |
|              |              | Bugfix: Resolve LazyLoadingProxy to fe_users relations                                                                                                                                                                |
| 8.2.4        | 2020-12-02   | Bugfix: Fix possible exception when extending powermail with own validators and using a confirmation view                                                                                                             |
| 8.2.3        | 2020-11-08   | Bugfix: Set tx_powermail_domain_model_mail.fe_user value for logged in users                                                                                                                                          |
|              |              | Bugfix: Fix link from PluginPreview to powermail module                                                                                                                                                               |
|              |              | Bugfix: Prevent possible exception if not existing form is selected in a plugin (e.g. from old data garbage)                                                                                                          |
|              |              | Bugfix: Re-add english mail label for backend list view                                                                                                                                                               |
|              |              | Task: Small code cleanup                                                                                                                                                                                              |
|              |              | Task: Small documentation update                                                                                                                                                                                      |
| 8.2.2        | 2020-10-21   | Bugfix: Fix false positive error message in frontend "TypoScript is missing" together with marketing information                                                                                                      |
|              |              | Bugfix: Fix a possible type hint error logs when no referrer is available                                                                                                                                             |
|              |              | Bugfix: Fix a possible type hint exception if TSFE is not available                                                                                                                                                   |
| 8.2.1        | 2020-10-05   | Bugfix: Fix AJAX requests for hiding/enabling and deleting mails in backend module                                                                                                                                    |
|              |              | Bugfix: Fix a possible type hint exception when powermail gets extended from third party extensions                                                                                                                   |
|              |              | Bugfix: Fix a possible type hint exception in Pi2                                                                                                                                                                     |
| 8.2.0        | 2020-09-22   | Feature: Add a Services.yaml with a default configuration to improve extension possibilities                                                                                                                          |
|              |              | Bugfix: Fix a possible type hint exception in FormSelectorUserFunc                                                                                                                                                    |
|              |              | Bugfix: Add missing translations in TCA for default fields again                                                                                                                                                      |
| 8.1.4        | 2020-09-01   | Bugfix: Fix possible exception with logged in frontend users and optin                                                                                                                                                |
|              |              | Task: Fix typo in documentation                                                                                                                                                                                       |
| 8.1.3        | 2020-08-31   | Bugfix: Don't parse FlexForm field receivers if a different type is used                                                                                                                                              |
|              |              | Bugfix: Prevent exception when saving values to third party table                                                                                                                                                     |
| 8.1.2        | 2020-07-10   | Bugfix: Fix typo in TypoScript condition for Pi2                                                                                                                                                                      |
|              |              | Task: Small documentation update                                                                                                                                                                                      |
| 8.1.1        | 2020-06-22   | Bugfix: Fix mapping to fe_users and fe_groups                                                                                                                                                                         |
|              |              | Bugfix: Fix some wrong type hint declarations                                                                                                                                                                         |
|              |              | Bugfix: Fix missing filenames and extensions for XLS/CSV exports in Pi2                                                                                                                                               |
| 8.1.0        | 2020-03-29   | Feature: Make $settings writable from signals in all controllers                                                                                                                                                      |
|              |              | Bugfix: Unique validator should also work with double opt in feature                                                                                                                                                  |
|              |              | Bugfix: Prevent exception if there are no mails stored yet                                                                                                                                                            |
|              |              | Bugfix: Fix wrong signal name in documentation                                                                                                                                                                        |
|              |              | Bugfix: Fix field type in FlexForm for redirect after submit                                                                                                                                                          |
|              |              | Bugfix: Support t3:// links for redirection now                                                                                                                                                                       |
|              |              | Bugfix: Preselect only if there is a "*" set in configuration (select, checkboxes, radiobuttons)                                                                                                                      |
| 8.0.2        | 2020-02-22   | Bugfix: Typehints in 8.x prevents plugins from inserting into pages with an exception                                                                                                                                 |
|              |              | Bugfix: Update some sql queries with changed fieldnames in powermail 8                                                                                                                                                |
| 8.0.1        | 2020-02-19   | Bugfix: Small fix in ext_tables.sql for new fieldnames                                                                                                                                                                |
| 8.0.0 (!!!)  | 2020-02-17   | Please use the TYPO3 upgrade wizard for an update to powermail 8.x!                                                                                                                                                   |
|              |              | Task: Support for TYPO3 10 (and only for this version)                                                                                                                                                                |
|              |              | Task: Add typehints for all functions                                                                                                                                                                                 |
|              |              | Task: Remove outdated functions                                                                                                                                                                                       |
|              |              | Task: Update notations for validators, lazy loading, etc...                                                                                                                                                           |
|              |              | Task: Replace old conditions with new symfony conditions                                                                                                                                                              |
|              |              | Task: Use TSFE for all functions that listen to GET/POST now to support routing                                                                                                                                       |
|              |              | Task: Replace old extbase commandcontrollers with symfony commands                                                                                                                                                    |
|              |              | Task: Rename _field.pages to .page and _page.forms to .form and add an upgrade wizard for this                                                                                                                        |
|              |              | Task: _mail.sys_language_uid is now forced to -1 (also for _answer) and add an upgrade wizard for this                                                                                                                |
|              |              | Task: Change documentation from RST to markdown                                                                                                                                                                       |
|              |              | Task: Update automatic tests                                                                                                                                                                                          |
|              |              | Task: Code cleanup                                                                                                                                                                                                    |
| 7.4.0        | 2019-08-27   | Feature: Allow aborting of the email sending process via signal                                                                                                                                                       |
|              |              | Feature: Add a new signal optinConfirmActionAfterPersist                                                                                                                                                              |
|              |              | Feature: Use new documentation rendering                                                                                                                                                                              |
|              |              | Bugfix: Spamcheck fix while searching for links in answers with non-string values                                                                                                                                     |
|              |              | Bugfix: Fix double opt-in with an upload field                                                                                                                                                                        |
|              |              | Task: Change German wording for optin mails                                                                                                                                                                           |
|              |              | Task: Small cleanups                                                                                                                                                                                                  |
|              |              | Task: Update documentation                                                                                                                                                                                            |
| 7.3.1        | 2019-05-21   | Bugfix: Fix table fields for marketing information for mysql strict mode                                                                                                                                              |
|              |              | Bugfix: Ensure to render a-tags as absolute links in mails                                                                                                                                                            |
| 7.3.0        | 2019-04-09   | Task: Some small cleanup                                                                                                                                                                                              |
|              |              | Feature: Support the usage in helhum/typo3-secure-web (Captcha, Export and Extension Icon)                                                                                                                            |
|              |              | Feature: Pass $this->settings to initializeObjectSettings Signal for a manipulation of settings via SignalSlot                                                                                                        |
|              |              | Bugfix: Prevent exception in Pi2 in TYPO3 9.5 LTS                                                                                                                                                                     |
|              |              | Bugfix: Allow backend module usage together with EXT:securedownloads                                                                                                                                                  |
| 7.2.0        | 2019-02-18   | Task: Small code cleanup                                                                                                                                                                                              |
|              |              | Feature: Add a transient property to mail model                                                                                                                                                                       |
|              |              | Bugfix: Prevent type hint exception in PrefillFieldViewHelper                                                                                                                                                         |
|              |              | Bugfix: Fix a typo in a css class for a loading bar (AJAX submit)                                                                                                                                                     |
|              |              | Bugfix: Fixed a small typo                                                                                                                                                                                            |
| 7.1.0 (!!!)  | 2019-01-12   | Task: Unit test update                                                                                                                                                                                                |
|              |              | Task: Remove deprecated keys in ext_emconf.php                                                                                                                                                                        |
|              |              | !!! Bugfix: Make JavaScript work again in BE-Module in TYPO3 9.5 - Path of all JavaScript files changes from Resources/Public/JavaScripts/ to Resources/Public/JavaScript/ - maybe you have to adjust your TypoScript |
|              |              | Bugfix: Allow default values directly in PrefillFieldViewHelper                                                                                                                                                       |
|              |              | No mails are sent if database storing was disabled with the disclaimer feature                                                                                                                                        |
|              |              | Remove outdated eID inclusion                                                                                                                                                                                         |
|              |              | Show only allowed froms in plugin (in TYPO3 9.5)                                                                                                                                                                      |
| 7.0.0 (!!!)  | 2019-01-12   | Feature: Add a disclaimer link functionality to sender- and optinmail (sender can remove his own mail completely from database now)                                                                                   |
|              |              | Task: Increase general hash length from 10 to 64 characters (optin links and new disclaimer links)                                                                                                                    |
|              |              | Task: ome cleanup                                                                                                                                                                                                     |
|              |              | Bugfix: Reanimate location field (broken because of change in the google API). Now we're using openstreetmap for this                                                                                                 |
