

function ready(fn) {
	if (document.readyState != 'loading'){
		fn();
	} else {
		document.addEventListener('DOMContentLoaded', fn);
	}
}
ready(() => {
	// Default - Main.html
	const navbar = document.getElementById('main-navbar'),
			navbarHeight = navbar.clientHeight,
			navbarBreakpointWidth = document.body.getAttribute('data-navbar-breakpointwidth'),
			viewportWidth = parseFloat(getComputedStyle(document.querySelector('html'), null).width.replace("px", "")),
			onePageLayout = navbar.classList.contains('sectionMenu');

	var fixedNavbar = false;
	if ( navbar.classList.contains('fixed-top') || navbar.classList.contains('sticky-top') ) {
		fixedNavbar = true;
	}

	// Scroll anchor - Main.html
	if (window.location.hash) {
		t3sbScrollToAnchor(29, fixedNavbar, navbarHeight);
	}
				

	// Loading spinner - Main.html
	window.onload = function() {
		let spinner = document.getElementById('site-preloader');
		t3sbFadeOutEffect(spinner);
	};


	// LazyLoad - Main.html
	var customthreshold = 0;
	new LazyLoad({
		elements_selector: '.lazy',
		threshold: customthreshold
	});
				

	// Link to top - Main.html
	t3sbScrollToTop();


	// Searchbox - Navbar/Assets.html
	t3sbNavbarSearchbox(viewportWidth, navbarBreakpointWidth);
	window.addEventListener('resize', function(event) {	
		resizedViewportWidth = parseFloat(getComputedStyle(document.querySelector('html'), null).width.replace("px", ""));
		t3sbNavbarSearchbox(resizedViewportWidth, navbarBreakpointWidth);
	}, true);


	// Baguette Box (lightbox) - Partials/Layouts/Assets.html
	baguetteBox.run('.gallery, .image-gallery', {
		animation: 'fadeIn',
		noScrollbars: true
	});
		
});
